//
//  JSPreprocessing.js
//  OutlineExt
//

function getRootUrl()
{
    return window.location.origin
    ? window.location.origin + '/'
    : window.location.protocol + '/'+window.location.host + '/';
}


var OUExtensionJavaScriptClass = function() {};

OUExtensionJavaScriptClass.prototype =
{
    
run: function(arguments)
    {
        var url = window.location.href;
        var rootUrl = getRootUrl();
        var urlProtocol = window.location.protocol;
        var htmlText = '';
        var title = '';
        
        if (document.selection && document.selection.createRange)
        {
            var range = document.selection.createRange();
            htmlText = range.htmlText;
        }
        else if (window.getSelection)
        {
            var selection = window.getSelection();
            if (selection.rangeCount > 0)
            {
                range = selection.getRangeAt(0);
                var clonedSelection = range.cloneContents();
                var div = document.createElement('div');
                div.appendChild(clonedSelection);
                htmlText = div.innerHTML;
            }
        }
        
        if (htmlText.length == 0)
        {
            htmlText = document.documentElement.innerHTML;
            title = document.title;
        }
        
        arguments.completionFunction({'innerHTML': htmlText, 'rootUrl': rootUrl, 'url': url, 'urlProtocol' : urlProtocol, 'title': title});
    },
    
finalize: function(arguments)
    {
    }
    
};

var ExtensionPreprocessingJS = new OUExtensionJavaScriptClass;
